//void read_pulse_2(Char_t fname[80], Int_t event)
void read_pulse_3(Char_t fname[80])
{

  gROOT->SetStyle("Plain");
  gStyle->SetOptFit(111);
  TGaxis::SetMaxDigits(3);

  Char_t filename[100];

  strcpy(filename, "/scratch/hodgson/");
  strcat(filename, fname);
  strcat(filename, "/event_");

  Int_t event = 0;
  bool open_failed = false;

  while(!open_failed)
    {
      Char_t fullname[100];
      
      sprintf(fullname, "%s%06d", filename, event);
      
      //cout << "Opening " << fullname << endl;
      
      Int_t raw_Sample            = 0;
      Double_t raw_BeamIntensity  = 0.0;
      Double_t raw_TargetPosition = 0.0;
      Double_t raw_BeamPosition   = 0.0;
      Double_t raw_TotalBeamloss  = 0.0;
      Double_t raw_BLM7SUM        = 0.0;
      Double_t raw_BLM8SUM        = 0.0;
      
      Double_t ar_Sample[5001];
      Double_t ar_BeamIntensity[5001];
      Double_t ar_TargetPosition[5001];
      Double_t ar_BeamPosition[5001];
      Double_t ar_TotalBeamloss[5001];
      Double_t ar_BLM7SUM[5001];
      Double_t ar_BLM8SUM[5001];
      
      Double_t start_position_sum = 0.0;
      Double_t start_position_av[1000];
      Double_t event_idx[1000];      

      Double_t delta_position;
      Double_t min_depth = 100.0;
      Double_t time_min_depth[1000];  
      Double_t time_dip_start[1000];
      
      Double_t sum_depth;
      Double_t av_depth   = 0.0;
      Int_t count_1 = 0;
      
      Double_t delta_start_position = 0.0;
      
      bool dip_start_flag = true;
      
      Double_t total_time[1000];
      Double_t total_depth[1000];
 
      Double_t red_time_beam_on  = -1.0;
      Double_t red_time_beam_off = -1.0;
      Double_t time_beam_on[1000];
      Double_t time_beam_off[1000];

      Double_t min_bl7 = 100.0;
      Double_t beamloss_sector7[1000];

      ifstream fp1;
      fp1.open(fullname);
      
      if(fp1.is_open())
	{
	  event_idx[event] = event;
	  std::string line;
	  //Ignore the first 3 lines
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  
	  //Get the time stamp line
	  std::getline(fp1, line);
	  
	  //Chomp up timestamp line and put in a struct
	  for (int i=0; i<line.length(); i++)
	    if (line[i]=='_')
	      line[i]=' ';
	  std::istringstream ss(line);
	  int y, m, d, H, M, S;
	  ss >> y >> m >> d >> H >> M >> S;
	  
	  struct tm ts;
	  memset(&ts, 0, sizeof(ts));
	  ts.tm_year=y-1900;
	  ts.tm_mon=m;
	  ts.tm_mday=d;
	  ts.tm_hour=H;
	  ts.tm_min=M;
	  ts.tm_sec=S;
	  //Make the unixtime from timestamp
	  time_t t = mktime(&ts);
	  
	  //Ignore last 6 lines
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  std::getline(fp1, line);
	  
	  //cout << "Time " << t << endl;
	  
	  for(Int_t i = 0; i < 4999; i++)
	    {
	      
	      std::getline(fp1, line);
	      std::istringstream ss(line);
	      
	      ss
		>> raw_Sample
		>> raw_BeamIntensity
		>> raw_TargetPosition
		>> raw_BeamPosition
		>> raw_TotalBeamloss
		>> raw_BLM7SUM
		>> raw_BLM8SUM;
	  
	      ar_Sample[i]         = raw_Sample / 100.0;
	      ar_BeamIntensity[i]  = raw_BeamIntensity;
	      ar_TargetPosition[i] = raw_TargetPosition * 15.0 + 12.3;
	      ar_BeamPosition[i]   = 0.0;
	      ar_TotalBeamloss[i]  = raw_TotalBeamloss;
	      ar_BLM7SUM[i]        = raw_BLM7SUM; 
	      ar_BLM8SUM[i]        = raw_BLM8SUM;
	      
	      if(i > 0)
		{
		  delta_position = TMath::Abs(ar_TargetPosition[i] - ar_TargetPosition[i - 1]);
		}
	      
	      if(ar_TargetPosition[i] < min_depth && delta_position < 0.05)
		{
		  min_depth = ar_TargetPosition[i];
		  time_min_depth[event] = i / 100.0;
		}
	      
	      if(i < 100)
		start_position_sum += raw_TargetPosition;
	      
	      if(i == 100)
		start_position_av[event] = (start_position_sum / 100.0) * 15.0 + 12.3;
	      
	      
	      
	      if(count_1 <= 9)
		{
		  sum_depth += ar_TargetPosition[i];
		  count_1++;
		}
	      if(count_1 == 10)
		{
		  av_depth = sum_depth / 10.0;
		  sum_depth = 0.0;
		  count_1 = 0;
		  //cout << i << " "  << "Average Depth: " << av_depth << endl;
		}
	      
	      delta_start_position = TMath::Abs(start_position_av[event] - av_depth);
	      //cout << i << " " << delta_start_position << endl;
	      
	      if(i > 99 && dip_start_flag && delta_start_position > 0.3)
		{
		  dip_start_flag = false;
		  time_dip_start[event] = i / 100.0;
		}
	      //This section finds the Beam On and Beam Off times
	      if(i > 500) 
		{
		  if(raw_BeamIntensity < 0.1)
		    {
		      ar_BeamIntensity[i] = 0.0;
		      if(red_time_beam_on >= 0 && red_time_beam_off < 0)
			{
			  red_time_beam_off = i / 100.0;
			  time_beam_off[event] = i / 100.0;
			}
		    }
		  else
		    {
		      ar_BeamIntensity[i] = 1.0;
		      if(red_time_beam_on < 0)
			{
			  red_time_beam_on    = i / 100.0;
			  time_beam_on[event] = i / 100.0;
			}
		    }
		}
	      
	      if(raw_BLM7SUM < min_bl7)
		{
		  min_bl7 = raw_BLM7SUM;
		}

	      beamloss_sector7[event] = min_bl7 * -1000.0;

	    }
	       
	  //cout << "Start Position: " << start_position_av << endl;
	  //cout << "Start Time:     " << time_dip_start << endl;
      
	  TGraph * tg_position = new TGraph(5001, ar_Sample, ar_TargetPosition);
	  
	  TF1 *p1 = new TF1("p1", "pol2", time_min_depth[event] - 7.5, time_min_depth[event] + 8.5);
	  
	  Double_t par[3];
      
	  
	  //TCanvas * c1 = new TCanvas("c1", "Event Plot");
	  //c1->cd();
	  
	  tg_position->Fit(p1,"RQ");
	  //tg_position->Draw("AP");
	  
	  p1->GetParameters(&par[0]);
	  
	  Double_t fit_min_depth[1000];
	  Double_t fit_time_min_depth[1000];
	  
	  Double_t accel_1[1000];
	  Double_t mid_point_x;
	  Double_t pulse_width[1000];
	  
	  mid_point_x = time_dip_start[event] + ((fit_time_min_depth[event] - time_dip_start[event]) / 2.0);
	  

	  fit_time_min_depth[event] = (-1.0 * par[1]) / (2.0 * par[2]);
	  fit_min_depth[event] = par[2] * (fit_time_min_depth[event] * fit_time_min_depth[event])
	    + par[1] * fit_time_min_depth[event]
	    + par[0];
	  
	  total_time[event] = fit_time_min_depth[event] - time_dip_start[event];
	  total_depth[event] = start_position_av[event] - fit_min_depth[event]; 
	  
	  accel_1[event] = 1000.0 * (4.0 * total_depth[event]) / (total_time[event] * total_time[event]);
	  
	  pulse_width[event] = 2.0 * (fit_time_min_depth[event] - mid_point_x);
	  
	  //cout << "Raw Min Depth: " << min_depth << endl;    
	  //cout << "Raw Time Min Depth: " << time_min_depth << endl;
	  //cout << "Total Time          : " << total_time << endl;    
	  //cout << "Total Depth         : " << total_depth << endl;
	  
	  //cout << "Average Accleration : " << 1000.0 * accel_1 << endl;

	  cout.setf(ios::fixed);
	  cout << event << " ";
	  cout << t << " ";
	  
	  cout.precision(3);
	  
	  cout << (start_position_av[event])
	       << " "
	       << (time_dip_start[event])
	       << " "
	       << (time_beam_on[event])
	       << " "
	       << (time_beam_off[event])
	       << " "
	       << (fit_time_min_depth[event])
	       << " "
	       << (fit_min_depth[event])
	       << " "
	       << (total_depth[event])
	       << " "
	       << (total_time[event])
	       << " "
	       << (accel_1[event])
	       << " "
	       << (pulse_width[event])
	       << " "
	       << (beamloss_sector7[event])
	       << endl;
	}
      else
	open_failed = true;
      event++;
      
 
    }
  
  


}
